import{__decorate as e}from"../../_virtual/_tslib.js";import'./../../external/@lit/reactive-element/reactive-element.js';import{html as t}from'./../../external/lit-html/lit-html.js';import{LitElement as i}from'./../../external/lit-element/lit-element.js';import{customElement as s}from'./../../external/@lit/reactive-element/decorators/custom-element.js';import{property as o}from'./../../external/@lit/reactive-element/decorators/property.js';import{state as d}from'./../../external/@lit/reactive-element/decorators/state.js';import'./../../external/@lit/reactive-element/decorators/query-assigned-elements.js';import{ifDefined as l}from'./../../external/lit-html/directives/if-defined.js';import r from"./accordionItem.scss.js";import a from'./../../external/@carbon/icons/es/add/32.js';import n from'./../../external/@carbon/icons/es/subtract/32.js';let c=class extends i{constructor(){super(...arguments),this.startOpened=!1,this._index=1,this._showNumber=!1,this._first=!1,this._last=!1,this._opened=!1,this._filledHeader=!1,this._compact=!1,this._id=""}connectedCallback(){super.connectedCallback(),this.startOpened&&this.open(),this._id=crypto.randomUUID()}setIndex(e){this._index=e}setFirst(){this._first=!0}setLast(){this._last=!0}setShowNumbers(e){this._showNumber=e}setFilledHeader(e){this._filledHeader=e}setCompact(e){this._compact=e}open(){this._opened||this._toggleOpenState()}close(){this._opened&&this._toggleOpenState()}_handleClick(e){e.preventDefault(),this._toggleOpenState()}_handleKeypress(e){e.preventDefault()," "!=e.key&&"Enter"!=e.key||this._toggleOpenState()}_toggleOpenState(){this._opened?(this.ariaExpanded="false",this._opened=!1):(this.ariaExpanded="true",this._opened=!0)}get numberTemplate(){return this._showNumber?t`<div class="number">${this._index}</div>`:""}get iconTemplate(){return this.querySelector('[slot="icon"]')?t`<div class="icon"><slot name="icon"></slot></div>`:""}get subtitleTemplate(){return this.querySelector('[slot="subtitle"]')?t`
        <div class="kd-accordion-item-subtitle">
          <slot name="subtitle"></slot>
        </div>
      `:""}get expandIconTemplate(){return this._opened?t`
        <div class="expand-icon">
          <kd-icon .icon="${n}"></kd-icon>
        </div>
      `:t`
        <div class="expand-icon"><kd-icon .icon="${a}"></kd-icon></div>
      `}render(){let e="";return e+="kd-accordion-item",!0===this._first&&(e+=" first-item"),!0===this._last&&(e+=" last-item"),!0===this._opened&&(e+=" opened"),!0===this._filledHeader&&(e+=" filled-header"),!0===this._compact&&(e+=" compact"),t`
      <div class="${e}">
        <div
          class="kd-accordion-item-title"
          aria-controls="kd-accordion-item-detail-${this._index}"
          tabindex="${this._index}"
          @click="${e=>this._handleClick(e)}"
          @keypress="${e=>this._handleKeypress(e)}"
          id="${this._id}"
        >
          ${this.iconTemplate} ${this.numberTemplate}
          <div class="title">
            <div><slot name="title"></slot></div>
            ${this.subtitleTemplate}
          </div>
          ${this.expandIconTemplate}
        </div>

        <div
          class="kd-accordion-item-body"
          aria-expanded="${l(null===this.ariaExpanded?void 0:"true"===this.ariaExpanded)}"
          id="kd-accordion-item-body-${this._index}"
          aria-labelledby="kd-accordion-item-title-${this._index}"
        >
          <div class="kd-accordion-item-detail">
            <slot name="body"></slot>
          </div>
        </div>
      </div>
    `}};c.styles=[r],e([o({type:Boolean})],c.prototype,"startOpened",void 0),e([d()],c.prototype,"_index",void 0),e([d()],c.prototype,"_showNumber",void 0),e([d()],c.prototype,"_first",void 0),e([d()],c.prototype,"_last",void 0),e([d()],c.prototype,"_opened",void 0),e([d()],c.prototype,"_filledHeader",void 0),e([d()],c.prototype,"_compact",void 0),e([d()],c.prototype,"_id",void 0),c=e([s("kd-accordion-item")],c);export{c as AccordionItem};
//# sourceMappingURL=accordionItem.js.map
